local UnLocked
local Moveframes = {
    MinimapCluster,
    --PlayerFrame,
    --TargetFrame,
    CastingBarFrame,
    rBFS_BuffDragFrame,
    rBFS_DebuffDragFrame
} -- So we don't create a new table each time
for i, v in pairs(Moveframes) do
    local f = v
    f:SetMovable(true) -- only set thes conditions once when you start up
    f:EnableMouse(true)
    f:SetClampedToScreen(true)
    f:RegisterForDrag("LeftButton")
    f:SetScript(
        "OnDragStart",
        function(self)
            if not UnLocked then
                return
            end -- set the condition that will let dragging run
            self:StartMoving()
        end
    )
    f:SetScript(
        "OnDragStop",
        function(self)
            self:StopMovingOrSizing()
        end
    )
    f.Movetex = f:CreateTexture("ARTWORK")
    f.Movetex:SetAllPoints()
    f.Movetex:SetTexture("Interface/BUTTONS/WHITE8X8")
    local ObName = f:GetName()
    f.Movetex.text = f.text or f:CreateFontString(nil, "ARTWORK", "QuestMapRewardsFont")
    f.Movetex.text:SetAllPoints(true)
    f.Movetex.text:SetJustifyH("TOP")
    f.Movetex.text:SetJustifyV("TOP")
    f.Movetex.text:SetText(ObName)
    f.Movetex.text:SetFont("Fonts\\FRIZQT__.TTF", 08, "THICKOUTLINE")
    f.Movetex:SetColorTexture(1.0, 0.2, 0)
    f.Movetex:SetAlpha(0.5)
    f.Movetex:Hide()
    f.Movetex.text:Hide()
end
local function toggleMoveableFrames(show)
    for i, v in pairs(Moveframes) do
        local f = v
        f.Movetex:SetShown(show)
        f.Movetex.text:SetShown(show)
        UnLocked = show
        if (f == PlayerFrame or f == TargetFrame or f == BuffFrame) then
            f:RegisterForDrag("LeftButton")
            f:SetScript("OnDragStart", f.StartMoving)
            f:SetScript("OnDragStop", f.StopMovingOrSizing)
        end
    end
end
-- Reset
local function resetFramesPositions()
    for i, v in pairs(Moveframes) do
        local f = v
        f:ClearAllPoints()
        f.ClearAllPoints = function()
        end
    end
    PlayerFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -19, -4)
    TargetFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 250, -4)
    MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", 10, 10)
    C_Timer.After(
        0.5,
        function()
            QuestWatchFrame:SetPoint("TOPRIGHT", MinimapCluster, "BOTTOM", 45, -5)
        end
    )
end
SLASH_ABUI1 = "/frames"
function SlashCmdList.ABUI(msg, editbox)
    if (msg == "unlock") then
        align()
        toggleMoveableFrames(true)
    elseif (msg == "lock") then
        align()
        toggleMoveableFrames(false)
    elseif (msg == "reset") then
        resetFramesPositions()
    else
        return nil
    end
end
